/* Exemplo usando argumentos de linha de comando,
 * arquivos, ponteiros e arrays de ponteiros
 * Ex.: prog nome_arquivo
 */
/* Obtem frases do usuario e as grava em um arquivo. */

#include <stdio.h>
#include <string.h>

char *cigets (char *, int , FILE *);

#define TAM_FRASE   100

int main (int argc, char *argv[]) 
{
  char buffer[TAM_FRASE + 1] = "\n";
  char arquivo[TAM_FRASE + 1];
  char **frases;
  int i, nfrs;
  FILE *fp;

  if (argc < 2)
    do {
      printf("Entre o nome do arquivo: ");
    } while (cigets(arquivo, sizeof(arquivo), stdin) == NULL || ! strlen(arquivo));
  else if (argc == 2)
    strcpy (arquivo, argv[1]);

  if (argc > 2)
    printf("\nForma de uso: %s [arquivo]\n\n", argv[0]);
  else {
    fp = fopen (arquivo, "w+");
    
    if (fp == NULL)
      printf("Erro ao abrir arquivo %s\n", arquivo);
    else {
      frases = (char **) calloc (1, sizeof(char *));
      if (frases == NULL)
	printf ("ERRO DE ALOCACAO DE FRASES\n");
      else {
	for (nfrs = 0; strlen(buffer); nfrs++) {
	  printf("Entre com frase %d: ", nfrs + 1);
	  if(cigets(buffer, TAM_FRASE, stdin) != NULL)
	    if((*(frases + nfrs) = strdup(buffer)) != NULL)
	      frases = (char **) realloc (frases, (nfrs + 2) * sizeof(char *));
	}
	
	printf("\n=========================\n");
	
	for (i = 0 ; i < nfrs && fputs(*(frases + i), fp) != EOF; i++) {
	  fputs("\n", fp);
	  printf("Escrevendo frase %d: %s\n", i + 1, *(frases + i));
	}
	
	fclose(fp);     /* fecha arquivo */
      }  /* FIM (fp == NULL) */
    }
  }
}


/* Mesmo que fgets(), mas retira do buffer o caracter '\n' final que
 * fgets() insere no buffer de entrada */

char *cigets (char *buffer, int size, FILE *stream)
{
  int i;
  buffer = fgets(buffer, size, stream);
  
  /* elimina '\n' inserido por fgets() */
  if (buffer != NULL) {
    for (i = strlen(buffer); buffer[i] != '\n'; i--);
    buffer[i] = '\0';
  }
  
  return buffer;
}
